<?php
// Хук обновления заказа
// bool updateOrder (array $array, bool $informUser = false, string $text)
function BifitKassa_updateOrder($array = [], $informUser = false, $text = '')
{
	// options
	$option = MG::getSetting('bifitkassa-option');
	$option = stripslashes($option);
	$options = unserialize($option);
	
	// order
	$order = [];
	$id = Models_Order::getOrder('`id` = "' . $array['args'][0]['id'] . '"');
	array_walk_recursive($id, function ($item, $key) use (&$order) {
		$order[$key] = $item;
	});
	$data = Bifit::__getOrderData($order, $options);
	$data->test = $options['test'] === "1" ? '-test' : '';
	$data->token = $options['test'] === "1" 
		? 'P5cKbUUD9uSSrSlGdzspLblvBnD0GzTAE0cLmAPSEMxJ79DtLE' 
		: $options['token'];
	$status_id = $data->status_id;
	$payment_id = $data->payment_id;
	$paid = $data->paid;

	for ($i = 1; $i <= 5; $i++) {
		$use_type = $options['use_type_' . $i];

		if ($use_type) {
			$must_paid = $options['order_paid_' . $i];
			$pm_statuses = $options['pm_statuses_' . $i];
			$pm_ids = $options['pm_ids_' . $i];
			$use_refused = $options['lk_use_refused'];

			if ($i == 5 && $use_refused) {
				$lk_refused_statuses = $options['lk_refused_statuses'];

				if (
					isset($lk_refused_statuses) &&
					is_array($lk_refused_statuses) &&
					in_array($status_id, $lk_refused_statuses)
				) {
					$pm_statuses = array_merge(
						$pm_statuses,
						$lk_refused_statuses
					);
				}
			}

			if (
				isset($pm_ids) &&
				isset($pm_statuses) &&
				isset($payment_id) &&
				in_array($payment_id, $pm_ids) &&
				in_array($status_id, $pm_statuses)
			) {				

				if (isset($must_paid) && $must_paid != '-1' && !$paid) {
					continue;
				}			

				// update data
				$arr_rec_type = array(
					'1' => 'SALE',
					'2' => 'SALE_RETURN',
					'3' => 'PURCHASE',
					'4' => 'PURCHASE_RETURN'
				);

				$data->receipt_type = $arr_rec_type[$i];
				$data->tax_system = $options['tax_system_' . $i];

				if ($i == 5) {
					// update data
					$data->login = Bifit::__checkPhone($options['login']);
					$data->password = $options['password'];
					$data->org_id = $options['organization'];
					$data->trade_id = $options['trade_object'];
					$data->courier = $options['lk_courier_delivery'];
					$data->self = $options['lk_self_delivery'];
					$data->new_status = $options['lk_new_courier_order_status'];
					$data->use_refused = $options['lk_use_refused'];
					$data->refused_statuses = $options['lk_refused_statuses'];
					// do
					Bifit::__saveOrder($data);
				} else {
					// do
					Bifit::__doFiscalize($data);
				}
			}
		}
	}

	return true;
}